﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Policy;
using System.Text;
using System.Threading.Tasks;

namespace Scholarship_2
{
    class Program
    {
        // Name: Lucas Webber

        static void Main(string[] args)
        {
            // List of points to display "x" on
            List<(int x, int y)> dataPoints = new List<(int x, int y)>
            {
                (0, 0),
                (1, 1),
                (2, 2),
                (3, 2),
                (4, 1),
                (5, 0),
                (6, -1),
                (7, -2),
                (9, -1),
                (10, 0),
            };

            // Find the maximum and minimum coordinates from dataPoints and adjust the height and length of the graph to display all data points
            int maxX = dataPoints.Any() ? dataPoints.Max(point => point.x) : 0;
            int maxY = dataPoints.Any() ? dataPoints.Max(point => point.y) : 0;
            int minY = dataPoints.Any() ? dataPoints.Min(point => point.y) : 0;

            Draw(maxX, maxY, minY, dataPoints);
            Console.ReadKey();
        }

        static void Draw(int maxX, int maxY, int minY, List<(int x, int y)> dataPoints)
        {
            // Draw the y-axis with numbered labels and x-axis at y = 0
            for (int y = maxY; y >= minY; y--)
            {
                // Print the y-axis label with a 3-character wide space for alignment
                if (y == 0)
                {
                    Console.Write($" {y,2}+"); // Print '+' at the origin instead of '|'
                }
                else
                {
                    Console.Write($" {y,2}|"); // Print the y-axis label and '|'
                }

                // Draw the x-axis, data points, or empty space
                for (int x = 1; x <= maxX; x++)
                {
                    if (y == 0)
                    {
                        if (dataPoints.Contains((x, y))) // Check if (x, y) is a data point on the x-axis
                        {
                            Console.Write("x"); // Print "x" if there's a data point
                        }
                        else
                        {
                            Console.Write("-"); // Otherwise, print the x-axis line
                        }
                    }
                    else if (dataPoints.Contains((x, y))) // Check if (x, y) is a data point elsewhere
                    {
                        Console.Write("x"); // Print "x" at the data point
                    }
                    else
                    {
                        Console.Write(" "); // Otherwise, empty space
                    }
                }
                Console.WriteLine();
            }
            Console.WriteLine("\r\nPress any key to close the program");
        }
    }
}

/* Note from Lucas.
 * This program has been coded up to step F
   The origin point (+) and y axis (|) overrides any value points at (x, 0) or (0, 0) so any data points in the list on line 17 that have x = 0 will be overwritten.
   Inputting two values at the same place will only result in one value being displayed.
   While files for step G are inside the folder they were never used as I was out of time.

   The graph is completely dymanic so you can input any value in the list and it will extend to the highest number in the list, 
   however you can't use any -x axis values
   (The highest value i've tested was (100, -100)
*/